/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.niederschrift.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.niederschrift.entity.Niederschrift;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class NiederschriftExtendedDAO extends AbstractNiederschriftDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: KuerzelSchnelleingabeNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM Niederschrift obj WHERE obj.wahldurchfuehrungsgebiet.wahl.kennzeichen IS NOT NULL AND UPPER(obj.wahldurchfuehrungsgebiet.wahl.kennzeichen) = UPPER(?1) AND obj.wahldurchfuehrungsgebiet.wahl.wahltermin.wahldatum = ?2 AND obj.wahldurchfuehrungsgebiet.nummer IS NOT NULL AND UPPER(obj.wahldurchfuehrungsgebiet.nummer) = UPPER(?3) AND obj.niederschriftArt = ?4<br>
* SQL: <br>
*/
@Override
public java.util.List<Niederschrift> findByKuerzelSchnelleingabe( @javax.annotation.Nonnull java.lang.String wahlKennzeichen,  @javax.annotation.Nonnull java.util.Date wahlWahldatum,  @javax.annotation.Nonnull java.lang.String gebietNummer,  @javax.annotation.Nonnull de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArt) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Niederschrift.findByKuerzelSchnelleingabe" ,  wahlKennzeichen ,  wahlWahldatum ,  gebietNummer ,  niederschriftArt  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByKuerzelSchnelleingabe(): Miss");
        }

        cache.put(key, super.findByKuerzelSchnelleingabe( wahlKennzeichen ,  wahlWahldatum ,  gebietNummer ,  niederschriftArt  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByKuerzelSchnelleingabe(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Niederschrift>) cache.lookup(key));
    }

    return super.findByKuerzelSchnelleingabe( wahlKennzeichen ,  wahlWahldatum ,  gebietNummer ,  niederschriftArt  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT n FROM Niederschrift n WHERE n.wahldurchfuehrungsgebiet.wahl = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Niederschrift> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Niederschrift.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Niederschrift>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}
/**
* Name: WahldurchfuehrungsgebietNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT n FROM Niederschrift n WHERE n.wahldurchfuehrungsgebiet = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Niederschrift> findByWahldurchfuehrungsgebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet wahldurchfuehrungsgebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Niederschrift.findByWahldurchfuehrungsgebiet" ,  wahldurchfuehrungsgebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahldurchfuehrungsgebiet(): Miss");
        }

        cache.put(key, super.findByWahldurchfuehrungsgebiet( wahldurchfuehrungsgebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahldurchfuehrungsgebiet(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Niederschrift>) cache.lookup(key));
    }

    return super.findByWahldurchfuehrungsgebiet( wahldurchfuehrungsgebiet  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
